# coding: utf-8

"""
    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class ResendOTPRequest(BaseModel):
    """
    ResendOTPRequest
    """
    idempotency_key: StrictStr = Field(..., alias="idempotencyKey", description="Universally unique identifier (UUID v4) idempotency key. This key is utilized to ensure exactly-once execution of mutating requests. To create a UUIDv4 go to [uuidgenerator.net](https://www.uuidgenerator.net). If the same key is reused, it will be treated as the same request and the original response will be returned.")
    otp_token: StrictStr = Field(..., alias="otpToken", description="The OTP is bound on a user and purpose, and uses this value to identify the request.")
    email: StrictStr = Field(..., description="Sends OTP email to the destination address.")
    device_id: StrictStr = Field(..., alias="deviceId", description="Get the device id from SDK, and the deviceToken is bound with this device id.")
    __properties = ["idempotencyKey", "otpToken", "email", "deviceId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ResendOTPRequest:
        """Create an instance of ResendOTPRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ResendOTPRequest:
        """Create an instance of ResendOTPRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ResendOTPRequest.parse_obj(obj)

        _obj = ResendOTPRequest.parse_obj({
            "idempotency_key": obj.get("idempotencyKey"),
            "otp_token": obj.get("otpToken"),
            "email": obj.get("email"),
            "device_id": obj.get("deviceId")
        })
        return _obj


