# coding: utf-8

"""
    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictStr, conlist, validator
from circle.web3.user_controlled_wallets.models.risk_category import RiskCategory
from circle.web3.user_controlled_wallets.models.risk_score import RiskScore
from circle.web3.user_controlled_wallets.models.risk_type import RiskType

class RiskSignal(BaseModel):
    """
    Risk signal that includes source, value, and risk type, risk score and risk category.
    """
    source: StrictStr = Field(..., description="Source of the risk signal.")
    source_value: StrictStr = Field(..., alias="sourceValue", description="Value of the source. For example, if source is “ADDRESS”. The source value would be an blockchain address.")
    risk_score: RiskScore = Field(..., alias="riskScore")
    risk_categories: conlist(RiskCategory) = Field(..., alias="riskCategories", description="List of risk categories for the signal.")
    type: RiskType = Field(...)
    __properties = ["source", "sourceValue", "riskScore", "riskCategories", "type"]

    @validator('source')
    def source_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('ADDRESS', 'BLOCKCHAIN', 'ASSET'):
            raise ValueError("must be one of enum values ('ADDRESS', 'BLOCKCHAIN', 'ASSET')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RiskSignal:
        """Create an instance of RiskSignal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RiskSignal:
        """Create an instance of RiskSignal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RiskSignal.parse_obj(obj)

        _obj = RiskSignal.parse_obj({
            "source": obj.get("source"),
            "source_value": obj.get("sourceValue"),
            "risk_score": obj.get("riskScore"),
            "risk_categories": obj.get("riskCategories"),
            "type": obj.get("type")
        })
        return _obj


